/*!
 * \file
 * \brief Doxygen test file
 * \author Adam Piatyszek
 *
 * $Date: $
 * $Revision: $
 *
 * -------------------------------------------------------------------------
 *
 * Copyright (C) 2006, 2007  (see AUTHORS file for a list of contributors)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * -------------------------------------------------------------------------
 */

#ifndef TEST_H
#define TEST_H

#include <iostream>

template<typename T>
class A {
public:
  //! Default constructor
  A(): a(T(0)) {}
  //! Default destructor
  ~A() {}
  //! Set method
  void set(const T& a_in);
private:
  T a;
};

template<typename T>
void A<T>::set(const T& a_in)
{
  std::cout << "set(T)\n";
  a = a_in;
}

//! Specialization of \c set() with \c int
template<> 
void A<int>::set(const int& a_in);


#endif /* TEST_H */
